
var id = Math.random().toString();
var currentName = '◆閲覧者';


function outputResultMessage(message)
{
	var now = new Date();
	var time = now.getHours() >= 10 ? now.getHours() : '0' + now.getHours();
	time += ':' + ( now.getMinutes() >= 10 ? now.getMinutes() : '0' + now.getMinutes() );
	time += ':' + ( now.getSeconds() >= 10 ? now.getSeconds() : '0' + now.getSeconds() );
	document.getElementById('result').innerHTML = '\n\t\t\t\t<li>' + time + ' ' + message + '</li>' + document.getElementById('result').innerHTML;
}



function createHttpRequest()
{
	if (window.ActiveXObject)
	{
		try
		{
			return new ActiveXObject('Msxml2.XMLHTTP');
		}
		catch (exception1)
		{
			try
			{
				return new ActiveXObject('Microsoft.XMLHTTP');
			}
			catch (exception2)
			{
				return false;
			}
		}
	}
	if ( window.XMLHttpRequest ) return new XMLHttpRequest();
	return false;
}



function login()
{
	outputResultMessage('入室処理開始');

	var name = document.getElementById('name').value;
	if (!name)
	{
		outputResultMessage('入室処理失敗 - ユーザー名が指定されていません．');
		return;
	}

	var httpRequest = createHttpRequest();
	if (!httpRequest)
	{
		outputResultMessage('入室処理失敗 - このブラウザは対応していません．');
		return;
	}
		
	httpRequest.open( 'GET' , 'chat.cgi?mode=login&id=' + id + '&name=' + encodeURIComponent(name) , true );
	httpRequest.setRequestHeader('If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT');
	httpRequest.onreadystatechange = function()
	{
		if ( httpRequest.readyState == 4 )
		{
			if ( httpRequest.status != 200 ) outputResultMessage('入室処理失敗 - サーバーエラーが発生しました．');
			else outputResultMessage( httpRequest.responseText );
		}
	}
	httpRequest.send(null);
}



function logout()
{
	outputResultMessage('退室処理開始');

	var httpRequest = createHttpRequest();
	if (!httpRequest)
	{
		outputResultMessage('退室処理失敗 - このブラウザは対応していません．');
		return;
	}

	httpRequest.open( 'GET' , 'chat.cgi?mode=logout&id=' + id , true );
	httpRequest.setRequestHeader('If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT');
	httpRequest.onreadystatechange = function()
	{
		if ( httpRequest.readyState == 4 )
		{
			if ( httpRequest.status != 200 ) outputResultMessage('退室処理失敗 - サーバーエラーが発生しました．');
			else outputResultMessage( httpRequest.responseText );
		}
	}
	httpRequest.send(null);
}



function reload()
{
	outputResultMessage("更新処理開始");

	var httpRequest = createHttpRequest();
	if (!httpRequest)
	{
		outputResultMessage('更新処理失敗 - このブラウザは対応していません．');
		return;
	}

	httpRequest.open( 'GET' , 'chat.cgi?mode=reload&id=' + id , true );
	httpRequest.setRequestHeader('If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT');
	httpRequest.onreadystatechange = function()
	{
		if ( httpRequest.readyState == 4 )
		{
			if ( httpRequest.status != 200 )
			{
				outputResultMessage('更新処理失敗 - サーバーエラーが発生しました．');
				setTimeout( 'reload()' , 10000 );
			}
			else if ( httpRequest.responseText == '更新処理完了 - 更新はありません．' )
			{
				outputResultMessage('更新処理完了 - 更新はありません．');
				setTimeout( 'reload()' , 3000 );
			}
			else if ( httpRequest.responseText == '更新処理失敗 - 切断済みです．ブラウザでリロードしてください．' )
			{
				outputResultMessage('更新処理失敗 - 切断済みです．ブラウザでリロードしてください．');
				return;
			}
			else
			{
				var data = httpRequest.responseText.split('<>\n');
				if ( currentName != data[0] )
				{
					if ( data[0] == '◆閲覧者' )
					{
						document.getElementById('console').innerHTML = '\n\t\t\t\t<form action="." onsubmit="login(); return false;">\n\t\t\t\t\t名前: \n\t\t\t\t\t<input type="text" name="name" id="name" />\n\t\t\t\t\t<input type="submit" value="入室" />\n\t\t\t\t</form>\n\t\t\t';
					}
					else
					{
						document.getElementById('console').innerHTML = '\n\t\t\t\t<form action="." onsubmit="post(); return false;">\n\t\t\t\t\t文章: \n\t\t\t\t\t<input type="text" name="statement" id="statement" />\n\t\t\t\t\t<input type="submit" value="投稿" />\n\t\t\t\t\t<input type="button" onclick="logout(); return false;" value="退室" />\n\t\t\t\t\t<br />\n\t\t\t\t\tあなたは' + data[0] + 'です．\n\t\t\t\t</form>\n\t\t\t';
					}
					currentName = data[0];
				}
				document.getElementById('users').innerHTML = data[1];
				document.getElementById('right').innerHTML = data[2];
				outputResultMessage('更新処理完了');
				setTimeout( 'reload()' , 3000 );
			}
		}
	}
	httpRequest.send(null);
}



function post()
{
	outputResultMessage('投稿処理開始');

	var statement = document.getElementById('statement').value;
	if (!statement)
	{
		outputResultMessage('投稿処理失敗 - 文章が入力されていません．');
		return;
	}

	var httpRequest = createHttpRequest();
	if (!httpRequest)
	{
		outputResultMessage('投稿処理失敗 - このブラウザは対応していません．');
		return;
	}

	httpRequest.open( 'GET' , 'chat.cgi?mode=post&id=' + id + '&statement=' + encodeURIComponent(statement) , true );
	httpRequest.setRequestHeader('If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT');
	httpRequest.onreadystatechange = function()
	{
		if ( httpRequest.readyState == 4 )
		{
			if ( httpRequest.status != 200 ) outputResultMessage('投稿処理失敗 - サーバーエラーが発生しました．');
			else outputResultMessage( httpRequest.responseText );
		}
	}
	
	document.getElementById('statement').value = '';
	httpRequest.send(null);
}



function disconnect()
{
	outputResultMessage('切断処理開始');

	var httpRequest = createHttpRequest();
	if (!httpRequest)
	{
		outputResultMessage('切断処理失敗 - このブラウザは対応していません．');
		return;
	}

	httpRequest.open( 'GET' , 'chat.cgi?mode=disconnect&id=' + id , true );
	httpRequest.setRequestHeader('If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT');
	httpRequest.onreadystatechange = function()
	{
		if ( httpRequest.readyState == 4 )
		{
			if ( httpRequest.status != 200 ) outputResultMessage('切断処理失敗 - サーバーエラーが発生しました．');
			else outputResultMessage( httpRequest.responseText );
		}
	}
	httpRequest.send(null);
}
