


use Time::HiRes;

require 'configuration.pl';



package Lock;



# ロックします
# 引数 1  なし
# 返り値  成功なら現在のロックディレクトリ名，失敗なら0
sub new
{
	my $this = $_[0];
	my $now = Time::HiRes::time();
	my $lockDirectory = $main::configuration{'lockDirectory'} . $now;

	if ( rename( $main::configuration{'lockDirectory'} , $lockDirectory ) )
	{
		return bless( \$lockDirectory , $this );
	}

	# 現在のロックディレクトリを取得
	my $lockedTime = 0;
	opendir( DIRECTORY , './' );
	@directory = readdir( DIRECTORY );
	closedir( DIRECTORY );
	while ( @directory )
	{
		if ( /^$main::configuration{'lockDirectory'}([0-9\.]+)/ )
		{
			$lockedTime = $1;
			last;
		}
	}

	# ロックの期限切れチェック
	if (
		$lockedTime and
		$now - $lockedTime >= $main::configuration{'destroyLockTime'} and
		rename( $main::configuration{'lockDirectory'} . $lockedTime , $lockDirectory ) )
	{
		return bless( \$lockDirectory , $this );
	}
	return 0;
}



# ロックを解除します
# 引数 1  なし
# 返り値  なし
sub DESTROY
{
	my $this = $_[0];
	rename( $$this , $main::configuration{'lockDirectory'} );
}



1;
